require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&__x86_64__)) {
    unless(defined(&XENPV)) {
	eval 'sub MAXCPUS () {256;}' unless defined(&MAXCPUS);
    }
    if(defined(&_KERNEL)) {
	require 'machine/cpu.ph';
	if(defined(&_KERNEL_OPT)) {
	    require './amd64/opt_kasan.ph';
	    require './amd64/opt_kmsan.ph';
	    require './amd64/opt_svs.ph';
	}
    }
    eval 'sub _MACHINE () { &amd64;}' unless defined(&_MACHINE);
    eval 'sub MACHINE () {"amd64";}' unless defined(&MACHINE);
    eval 'sub _MACHINE_ARCH () { &x86_64;}' unless defined(&_MACHINE_ARCH);
    eval 'sub MACHINE_ARCH () {"x86_64";}' unless defined(&MACHINE_ARCH);
    eval 'sub MID_MACHINE () { &MID_X86_64;}' unless defined(&MID_MACHINE);
    eval 'sub ALIGNED_POINTER {
        my($p,$t) = @_;
	    eval q(1);
    }' unless defined(&ALIGNED_POINTER);
    eval 'sub ALIGNED_POINTER_LOAD {
        my($q,$p,$t) = @_;
	    eval q( &memcpy(($q), ($p), $sizeof{$t}));
    }' unless defined(&ALIGNED_POINTER_LOAD);
    eval 'sub STACK_ALIGNBYTES () {(16- 1);}' unless defined(&STACK_ALIGNBYTES);
    eval 'sub ALIGNBYTES32 () {($sizeof{\'int\'} - 1);}' unless defined(&ALIGNBYTES32);
    eval 'sub ALIGN32 {
        my($p) = @_;
	    eval q(((($p) +  &ALIGNBYTES32) &~ &ALIGNBYTES32));
    }' unless defined(&ALIGN32);
    eval 'sub PGSHIFT () {12;}' unless defined(&PGSHIFT);
    eval 'sub NBPG () {(1<<  &PGSHIFT);}' unless defined(&NBPG);
    eval 'sub PGOFSET () {( &NBPG-1);}' unless defined(&PGOFSET);
    eval 'sub NPTEPG () {( &NBPG/($sizeof{ &pt_entry_t}));}' unless defined(&NPTEPG);
    eval 'sub MAXIOMEM () {0xffffffffffff;}' unless defined(&MAXIOMEM);
    if(defined(&KMSAN)) {
	eval 'sub MAXPHYSMEM () {0x8000000000;}' unless defined(&MAXPHYSMEM);
    } else {
	eval 'sub MAXPHYSMEM () {0x100000000000;}' unless defined(&MAXPHYSMEM);
    }
    eval 'sub KERNBASE () {0xffffffff80000000;}' unless defined(&KERNBASE);
    eval 'sub KERNTEXTOFF () {0xffffffff80200000;}' unless defined(&KERNTEXTOFF);
    eval 'sub BTOPKERNBASE () {( &KERNBASE >>  &PGSHIFT);}' unless defined(&BTOPKERNBASE);
    eval 'sub KERNTEXTOFF_HI () {0xffffffff;}' unless defined(&KERNTEXTOFF_HI);
    eval 'sub KERNTEXTOFF_LO () {0x80200000;}' unless defined(&KERNTEXTOFF_LO);
    eval 'sub KERNBASE_HI () {0xffffffff;}' unless defined(&KERNBASE_HI);
    eval 'sub KERNBASE_LO () {0x80000000;}' unless defined(&KERNBASE_LO);
    eval 'sub SSIZE () {1;}' unless defined(&SSIZE);
    eval 'sub SINCR () {1;}' unless defined(&SINCR);
    if(defined(&KASAN) || defined(&KMSAN)) {
	eval 'sub UPAGES () {8;}' unless defined(&UPAGES);
    }
 elsif(defined(&SVS)) {
	eval 'sub UPAGES () {6;}' unless defined(&UPAGES);
    } else {
	eval 'sub UPAGES () {5;}' unless defined(&UPAGES);
    }
    eval 'sub USPACE () {( &UPAGES *  &NBPG);}' unless defined(&USPACE);
    unless(defined(&MSGBUFSIZE)) {
	eval 'sub MSGBUFSIZE () {(16* &NBPG);}' unless defined(&MSGBUFSIZE);
    }
    eval 'sub MSIZE () {512;}' unless defined(&MSIZE);
    unless(defined(&MCLSHIFT)) {
	eval 'sub MCLSHIFT () {11;}' unless defined(&MCLSHIFT);
    }
    eval 'sub MCLBYTES () {(1<<  &MCLSHIFT);}' unless defined(&MCLBYTES);
    unless(defined(&NFS_RSIZE)) {
	eval 'sub NFS_RSIZE () {32768;}' unless defined(&NFS_RSIZE);
    }
    unless(defined(&NFS_WSIZE)) {
	eval 'sub NFS_WSIZE () {32768;}' unless defined(&NFS_WSIZE);
    }
    eval 'sub NKMEMPAGES_MIN_DEFAULT () {((8* 1024* 1024) >>  &PAGE_SHIFT);}' unless defined(&NKMEMPAGES_MIN_DEFAULT);
    eval 'sub NKMEMPAGES_MAX_UNLIMITED () {1;}' unless defined(&NKMEMPAGES_MAX_UNLIMITED);
    eval 'sub x86_round_pdr {
        my($x) = @_;
	    eval q((((($x)) + ( &NBPD_L2 - 1)) & ~( &NBPD_L2 - 1)));
    }' unless defined(&x86_round_pdr);
    eval 'sub x86_trunc_pdr {
        my($x) = @_;
	    eval q((($x) & ~( &NBPD_L2 - 1)));
    }' unless defined(&x86_trunc_pdr);
    eval 'sub x86_btod {
        my($x) = @_;
	    eval q((($x) >>  &L2_SHIFT));
    }' unless defined(&x86_btod);
    eval 'sub x86_dtob {
        my($x) = @_;
	    eval q((($x) <<  &L2_SHIFT));
    }' unless defined(&x86_dtob);
    eval 'sub x86_round_page {
        my($x) = @_;
	    eval q((((($x)) +  &PGOFSET) & ~ &PGOFSET));
    }' unless defined(&x86_round_page);
    eval 'sub x86_trunc_page {
        my($x) = @_;
	    eval q((($x) & ~ &PGOFSET));
    }' unless defined(&x86_trunc_page);
    eval 'sub x86_btop {
        my($x) = @_;
	    eval q((($x) >>  &PGSHIFT));
    }' unless defined(&x86_btop);
    eval 'sub x86_ptob {
        my($x) = @_;
	    eval q((($x) <<  &PGSHIFT));
    }' unless defined(&x86_ptob);
    eval 'sub btop {
        my($x) = @_;
	    eval q( &x86_btop($x));
    }' unless defined(&btop);
    eval 'sub ptob {
        my($x) = @_;
	    eval q( &x86_ptob($x));
    }' unless defined(&ptob);
} else {
    require 'i386/param.ph';
}
1;
