require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_AMD64_PTRACE_H_)) {
    eval 'sub _AMD64_PTRACE_H_ () {1;}' unless defined(&_AMD64_PTRACE_H_);
    if(defined(&__x86_64__)) {
	eval 'sub PT_STEP () {( &PT_FIRSTMACH + 0);}' unless defined(&PT_STEP);
	eval 'sub PT_GETREGS () {( &PT_FIRSTMACH + 1);}' unless defined(&PT_GETREGS);
	eval 'sub PT_SETREGS () {( &PT_FIRSTMACH + 2);}' unless defined(&PT_SETREGS);
	eval 'sub PT_GETFPREGS () {( &PT_FIRSTMACH + 3);}' unless defined(&PT_GETFPREGS);
	eval 'sub PT_SETFPREGS () {( &PT_FIRSTMACH + 4);}' unless defined(&PT_SETFPREGS);
	eval 'sub PT_GETDBREGS () {( &PT_FIRSTMACH + 5);}' unless defined(&PT_GETDBREGS);
	eval 'sub PT_SETDBREGS () {( &PT_FIRSTMACH + 6);}' unless defined(&PT_SETDBREGS);
	eval 'sub PT_SETSTEP () {( &PT_FIRSTMACH + 7);}' unless defined(&PT_SETSTEP);
	eval 'sub PT_CLEARSTEP () {( &PT_FIRSTMACH + 8);}' unless defined(&PT_CLEARSTEP);
	eval 'sub PT_GETXSTATE () {( &PT_FIRSTMACH + 9);}' unless defined(&PT_GETXSTATE);
	eval 'sub PT_SETXSTATE () {( &PT_FIRSTMACH + 10);}' unless defined(&PT_SETXSTATE);
	if(defined(&_KERNEL)) {
	    eval 'sub PT_GETXMMREGS () {( &PT_FIRSTMACH + 11);}' unless defined(&PT_GETXMMREGS);
	    eval 'sub PT_SETXMMREGS () {( &PT_FIRSTMACH + 12);}' unless defined(&PT_SETXMMREGS);
	}
	eval 'sub __HAVE_PTRACE_MACHDEP () {1;}' unless defined(&__HAVE_PTRACE_MACHDEP);
	eval 'sub PT_MACHDEP_STRINGS () {"PT_STEP", "PT_GETREGS", "PT_SETREGS", "PT_GETFPREGS", "PT_SETFPREGS", "PT_GETDBREGS", "PT_SETDBREGS", "PT_SETSTEP", "PT_CLEARSTEP", "PT_GETXSTATE", "PT_SETXSTATE", "PT_GETXMMREGS", "PT_SETXMMREGS";}' unless defined(&PT_MACHDEP_STRINGS);
	require 'machine/reg.ph';
	eval 'sub PTRACE_REG_PC {
	    my($r) = @_;
    	    eval q(($r)-> $regs[ &_REG_RIP]);
	}' unless defined(&PTRACE_REG_PC);
	eval 'sub PTRACE_REG_FP {
	    my($r) = @_;
    	    eval q(($r)-> $regs[ &_REG_RBP]);
	}' unless defined(&PTRACE_REG_FP);
	eval 'sub PTRACE_REG_SET_PC {
	    my($r, $v) = @_;
    	    eval q(($r)-> $regs[ &_REG_RIP] = ($v));
	}' unless defined(&PTRACE_REG_SET_PC);
	eval 'sub PTRACE_REG_SP {
	    my($r) = @_;
    	    eval q(($r)-> $regs[ &_REG_RSP]);
	}' unless defined(&PTRACE_REG_SP);
	eval 'sub PTRACE_REG_INTRV {
	    my($r) = @_;
    	    eval q(($r)-> $regs[ &_REG_RAX]);
	}' unless defined(&PTRACE_REG_INTRV);
	eval 'sub PTRACE_ILLEGAL_ASM () { &__asm  &__volatile ("ud2" : : : "memory");}' unless defined(&PTRACE_ILLEGAL_ASM);
	eval 'sub PTRACE_BREAKPOINT () {(( &const  $uint8_t[]) { 0xcc });}' unless defined(&PTRACE_BREAKPOINT);
	eval 'sub PTRACE_BREAKPOINT_ASM () { &__asm  &__volatile ("int3" : : : "memory");}' unless defined(&PTRACE_BREAKPOINT_ASM);
	eval 'sub PTRACE_BREAKPOINT_SIZE () {1;}' unless defined(&PTRACE_BREAKPOINT_SIZE);
	eval 'sub PTRACE_BREAKPOINT_ADJ () {1;}' unless defined(&PTRACE_BREAKPOINT_ADJ);
	if(defined(&_KERNEL)) {
	    eval 'sub PTRACE_MACHDEP_REQUEST_CASES () { &case  &PT_GETXSTATE:  &case  &PT_SETXSTATE:  &case  &PT_GETXMMREGS:  &case  &PT_SETXMMREGS:;}' unless defined(&PTRACE_MACHDEP_REQUEST_CASES);
	    eval 'sub PTRACE_REGS_ALIGN () { &__aligned(16);}' unless defined(&PTRACE_REGS_ALIGN);
	    require 'sys/module_hook.ph';
	    if(defined(&EXEC_ELF32)) {
		require 'machine/netbsd32_machdep.ph';
	    }
	    eval 'sub PT64_GETXSTATE () { &PT_GETXSTATE;}' unless defined(&PT64_GETXSTATE);
	    eval 'sub COREDUMP_MACHDEP_LWP_NOTES {
	        my($l, $ns, $name) = @_;
    		eval q({ \'struct xstate\'  &xstate;  &memset( &xstate, 0, $sizeof{ &xstate});  &if (! &process_read_xstate($l,  &xstate)) {  &ELFNAMEEND( &coredump_savenote)($ns,  &CONCAT( &CONCAT( &PT,  &ELFSIZE),  &_GETXSTATE), $name,  &xstate, $sizeof{ &xstate}); } });
	    }' unless defined(&COREDUMP_MACHDEP_LWP_NOTES);
	}
	if(defined(&_KERNEL_OPT)) {
	    require './amd64/opt_compat_netbsd32.ph';
	    if(defined(&COMPAT_NETBSD32)) {
		require 'machine/netbsd32_machdep.ph';
		eval 'sub process_read_regs32 () { &netbsd32_process_read_regs;}' unless defined(&process_read_regs32);
		eval 'sub process_read_fpregs32 () { &netbsd32_process_read_fpregs;}' unless defined(&process_read_fpregs32);
		eval 'sub process_read_dbregs32 () { &netbsd32_process_read_dbregs;}' unless defined(&process_read_dbregs32);
		eval 'sub process_write_regs32 () { &netbsd32_process_write_regs;}' unless defined(&process_write_regs32);
		eval 'sub process_write_fpregs32 () { &netbsd32_process_write_fpregs;}' unless defined(&process_write_fpregs32);
		eval 'sub process_write_dbregs32 () { &netbsd32_process_write_dbregs;}' unless defined(&process_write_dbregs32);
		eval 'sub process_reg32 () {\'struct reg32\';}' unless defined(&process_reg32);
		eval 'sub process_fpreg32 () {\'struct fpreg32\';}' unless defined(&process_fpreg32);
		eval 'sub process_dbreg32 () {\'struct dbreg32\';}' unless defined(&process_dbreg32);
		eval 'sub PTRACE_TRANSLATE_REQUEST32 {
		    my($x) = @_;
    		    eval q( &netbsd32_ptrace_translate_request($x));
		}' unless defined(&PTRACE_TRANSLATE_REQUEST32);
	    }
	}
    } else {
	require 'i386/ptrace.ph';
    }
}
1;
