require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_64_TYPES_H_)) {
    eval 'sub _X86_64_TYPES_H_ () {1;}' unless defined(&_X86_64_TYPES_H_);
    if(defined(&__x86_64__)) {
	require 'sys/cdefs.ph';
	require 'sys/featuretest.ph';
	require 'machine/int_types.ph';
	if(defined(&_KERNEL)) {
	}
	if(defined(&_KERNEL) || defined(&_KMEMUSER) || defined(&_KERNTYPES) || defined(&_STANDALONE)) {
	    eval 'sub PRIxPADDR () {"lx";}' unless defined(&PRIxPADDR);
	    eval 'sub PRIxPSIZE () {"lx";}' unless defined(&PRIxPSIZE);
	    eval 'sub PRIuPSIZE () {"lu";}' unless defined(&PRIuPSIZE);
	    eval 'sub PRIxVADDR () {"lx";}' unless defined(&PRIxVADDR);
	    eval 'sub PRIxVSIZE () {"lx";}' unless defined(&PRIxVSIZE);
	    eval 'sub PRIuVSIZE () {"lu";}' unless defined(&PRIuVSIZE);
	    eval 'sub PRIxREGISTER () {"lx";}' unless defined(&PRIxREGISTER);
	    eval 'sub PRIxREGISTER32 () {"x";}' unless defined(&PRIxREGISTER32);
	}
	eval 'sub __CPU_SIMPLE_LOCK_PAD () {1;}' unless defined(&__CPU_SIMPLE_LOCK_PAD);
	eval 'sub __SIMPLELOCK_LOCKED () {1;}' unless defined(&__SIMPLELOCK_LOCKED);
	eval 'sub __SIMPLELOCK_UNLOCKED () {0;}' unless defined(&__SIMPLELOCK_UNLOCKED);
	if(! &__has_feature((defined(&undefined_behavior_sanitizer) ? &undefined_behavior_sanitizer : undef))  && !defined(&__SANITIZE_UNDEFINED__)) {
	    eval 'sub __NO_STRICT_ALIGNMENT () {1;}' unless defined(&__NO_STRICT_ALIGNMENT);
	}
	eval 'sub __HAVE_NEW_STYLE_BUS_H () {1;}' unless defined(&__HAVE_NEW_STYLE_BUS_H);
	eval 'sub __HAVE_CPU_COUNTER () {1;}' unless defined(&__HAVE_CPU_COUNTER);
	eval 'sub __HAVE_CPU_DATA_FIRST () {1;}' unless defined(&__HAVE_CPU_DATA_FIRST);
	eval 'sub __HAVE_CPU_BOOTCONF () {1;}' unless defined(&__HAVE_CPU_BOOTCONF);
	eval 'sub __HAVE_MD_CPU_OFFLINE () {1;}' unless defined(&__HAVE_MD_CPU_OFFLINE);
	eval 'sub __HAVE_SYSCALL_INTERN () {1;}' unless defined(&__HAVE_SYSCALL_INTERN);
	eval 'sub __HAVE_MINIMAL_EMUL () {1;}' unless defined(&__HAVE_MINIMAL_EMUL);
	eval 'sub __HAVE_ATOMIC64_OPS () {1;}' unless defined(&__HAVE_ATOMIC64_OPS);
	eval 'sub __HAVE_MM_MD_KERNACC () {1;}' unless defined(&__HAVE_MM_MD_KERNACC);
	eval 'sub __HAVE_ATOMIC_AS_MEMBAR () {1;}' unless defined(&__HAVE_ATOMIC_AS_MEMBAR);
	eval 'sub __HAVE_CPU_LWP_SETPRIVATE () {1;}' unless defined(&__HAVE_CPU_LWP_SETPRIVATE);
	eval 'sub __HAVE___LWP_GETPRIVATE_FAST () {1;}' unless defined(&__HAVE___LWP_GETPRIVATE_FAST);
	eval 'sub __HAVE_TLS_VARIANT_II () {1;}' unless defined(&__HAVE_TLS_VARIANT_II);
	eval 'sub __HAVE_COMMON___TLS_GET_ADDR () {1;}' unless defined(&__HAVE_COMMON___TLS_GET_ADDR);
	eval 'sub __HAVE_INTR_CONTROL () {1;}' unless defined(&__HAVE_INTR_CONTROL);
	eval 'sub __HAVE_CPU_RNG () {1;}' unless defined(&__HAVE_CPU_RNG);
	eval 'sub __HAVE_COMPAT_NETBSD32 () {1;}' unless defined(&__HAVE_COMPAT_NETBSD32);
	eval 'sub __HAVE_MM_MD_DIRECT_MAPPED_IO () {1;}' unless defined(&__HAVE_MM_MD_DIRECT_MAPPED_IO);
	eval 'sub __HAVE_MM_MD_DIRECT_MAPPED_PHYS () {1;}' unless defined(&__HAVE_MM_MD_DIRECT_MAPPED_PHYS);
	eval 'sub __HAVE_UCAS_FULL () {1;}' unless defined(&__HAVE_UCAS_FULL);
	eval 'sub __HAVE_BUS_SPACE_8 () {1;}' unless defined(&__HAVE_BUS_SPACE_8);
	if(defined(&_KERNEL_OPT)) {
	    eval 'sub __HAVE_RAS () {1;}' unless defined(&__HAVE_RAS);
	    require './amd64/opt_xen.ph';
	    require './amd64/opt_kasan.ph';
	    require './amd64/opt_kmsan.ph';
	    if(defined(&KASAN)) {
		eval 'sub __HAVE_KASAN_INSTR_BUS () {1;}' unless defined(&__HAVE_KASAN_INSTR_BUS);
	    }
	    if(defined(&__x86_64__)  && !defined(&XENPV)) {
		if(!defined(&KASAN)  && !defined(&KMSAN)) {
		    eval 'sub __HAVE_PCPU_AREA () {1;}' unless defined(&__HAVE_PCPU_AREA);
		    eval 'sub __HAVE_DIRECT_MAP () {1;}' unless defined(&__HAVE_DIRECT_MAP);
		}
		eval 'sub __HAVE_CPU_UAREA_ROUTINES () {1;}' unless defined(&__HAVE_CPU_UAREA_ROUTINES);
	    }
	}
    } else {
	require 'i386/types.ph';
    }
}
1;
