require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <avx512cdintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_AVX512CDINTRIN_H_INCLUDED)) {
    eval 'sub _AVX512CDINTRIN_H_INCLUDED () {1;}' unless defined(&_AVX512CDINTRIN_H_INCLUDED);
    unless(defined(&__AVX512CD__)) {
	eval 'sub __DISABLE_AVX512CD__ () {1;}' unless defined(&__DISABLE_AVX512CD__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_conflict_epi32 ( &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_vpconflictsi_512_mask (( &__v16si)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_conflict_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_vpconflictsi_512_mask (( &__v16si)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_conflict_epi32 ( &__mmask16  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_vpconflictsi_512_mask (( &__v16si)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_conflict_epi64 ( &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_vpconflictdi_512_mask (( &__v8di)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_conflict_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_vpconflictdi_512_mask (( &__v8di)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_conflict_epi64 ( &__mmask8  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_vpconflictdi_512_mask (( &__v8di)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_lzcnt_epi64 ( &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_vplzcntq_512_mask (( &__v8di)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_lzcnt_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_vplzcntq_512_mask (( &__v8di)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_lzcnt_epi64 ( &__mmask8  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_vplzcntq_512_mask (( &__v8di)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_lzcnt_epi32 ( &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_vplzcntd_512_mask (( &__v16si)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_lzcnt_epi32 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_vplzcntd_512_mask (( &__v16si)  &__A, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_lzcnt_epi32 ( &__mmask16  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_vplzcntd_512_mask (( &__v16si)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_broadcastmb_epi64 ( &__mmask8  &__A) { ( &__m512i)  &__builtin_ia32_broadcastmb512 ( &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_broadcastmw_epi32 ( &__mmask16  &__A) { ( &__m512i)  &__builtin_ia32_broadcastmw512 ( &__A); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_AVX512CD__)) {
	undef(&__DISABLE_AVX512CD__) if defined(&__DISABLE_AVX512CD__);
    }
}
1;
