require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <avx512pfintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_AVX512PFINTRIN_H_INCLUDED)) {
    eval 'sub _AVX512PFINTRIN_H_INCLUDED () {1;}' unless defined(&_AVX512PFINTRIN_H_INCLUDED);
    unless(defined(&__AVX512PF__)) {
	eval 'sub __DISABLE_AVX512PF__ () {1;}' unless defined(&__DISABLE_AVX512PF__);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_prefetch_i32gather_pd ( &__m256i  &__index,  &void  &const * &__addr, \'int\'  &__scale, \'int\'  &__hint) {  &__builtin_ia32_gatherpfdpd (( &__mmask8) 0xff, ( &__v8si)  &__index,  &__addr,  &__scale,  &__hint); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_prefetch_i32gather_ps ( &__m512i  &__index,  &void  &const * &__addr, \'int\'  &__scale, \'int\'  &__hint) {  &__builtin_ia32_gatherpfdps (( &__mmask16) 0xffff, ( &__v16si)  &__index,  &__addr,  &__scale,  &__hint); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_prefetch_i32gather_pd ( &__m256i  &__index,  &__mmask8  &__mask,  &void  &const * &__addr, \'int\'  &__scale, \'int\'  &__hint) {  &__builtin_ia32_gatherpfdpd ( &__mask, ( &__v8si)  &__index,  &__addr,  &__scale,  &__hint); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_prefetch_i32gather_ps ( &__m512i  &__index,  &__mmask16  &__mask,  &void  &const * &__addr, \'int\'  &__scale, \'int\'  &__hint) {  &__builtin_ia32_gatherpfdps ( &__mask, ( &__v16si)  &__index,  &__addr,  &__scale,  &__hint); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_prefetch_i64gather_pd ( &__m512i  &__index,  &void  &const * &__addr, \'int\'  &__scale, \'int\'  &__hint) {  &__builtin_ia32_gatherpfqpd (( &__mmask8) 0xff, ( &__v8di)  &__index,  &__addr,  &__scale,  &__hint); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_prefetch_i64gather_ps ( &__m512i  &__index,  &void  &const * &__addr, \'int\'  &__scale, \'int\'  &__hint) {  &__builtin_ia32_gatherpfqps (( &__mmask8) 0xff, ( &__v8di)  &__index,  &__addr,  &__scale,  &__hint); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_prefetch_i64gather_pd ( &__m512i  &__index,  &__mmask8  &__mask,  &void  &const * &__addr, \'int\'  &__scale, \'int\'  &__hint) {  &__builtin_ia32_gatherpfqpd ( &__mask, ( &__v8di)  &__index,  &__addr,  &__scale,  &__hint); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_prefetch_i64gather_ps ( &__m512i  &__index,  &__mmask8  &__mask,  &void  &const * &__addr, \'int\'  &__scale, \'int\'  &__hint) {  &__builtin_ia32_gatherpfqps ( &__mask, ( &__v8di)  &__index,  &__addr,  &__scale,  &__hint); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_prefetch_i32scatter_pd ( &void * &__addr,  &__m256i  &__index, \'int\'  &__scale, \'int\'  &__hint) {  &__builtin_ia32_scatterpfdpd (( &__mmask8) 0xff, ( &__v8si)  &__index,  &__addr,  &__scale,  &__hint); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_prefetch_i32scatter_ps ( &void * &__addr,  &__m512i  &__index, \'int\'  &__scale, \'int\'  &__hint) {  &__builtin_ia32_scatterpfdps (( &__mmask16) 0xffff, ( &__v16si)  &__index,  &__addr,  &__scale,  &__hint); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_prefetch_i32scatter_pd ( &void * &__addr,  &__mmask8  &__mask,  &__m256i  &__index, \'int\'  &__scale, \'int\'  &__hint) {  &__builtin_ia32_scatterpfdpd ( &__mask, ( &__v8si)  &__index,  &__addr,  &__scale,  &__hint); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_prefetch_i32scatter_ps ( &void * &__addr,  &__mmask16  &__mask,  &__m512i  &__index, \'int\'  &__scale, \'int\'  &__hint) {  &__builtin_ia32_scatterpfdps ( &__mask, ( &__v16si)  &__index,  &__addr,  &__scale,  &__hint); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_prefetch_i64scatter_pd ( &void * &__addr,  &__m512i  &__index, \'int\'  &__scale, \'int\'  &__hint) {  &__builtin_ia32_scatterpfqpd (( &__mmask8) 0xff, ( &__v8di)  &__index, &__addr,  &__scale,  &__hint); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_prefetch_i64scatter_ps ( &void * &__addr,  &__m512i  &__index, \'int\'  &__scale, \'int\'  &__hint) {  &__builtin_ia32_scatterpfqps (( &__mmask8) 0xff, ( &__v8di)  &__index,  &__addr,  &__scale,  &__hint); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_prefetch_i64scatter_pd ( &void * &__addr,  &__mmask8  &__mask,  &__m512i  &__index, \'int\'  &__scale, \'int\'  &__hint) {  &__builtin_ia32_scatterpfqpd ( &__mask, ( &__v8di)  &__index,  &__addr,  &__scale,  &__hint); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_prefetch_i64scatter_ps ( &void * &__addr,  &__mmask8  &__mask,  &__m512i  &__index, \'int\'  &__scale, \'int\'  &__hint) {  &__builtin_ia32_scatterpfqps ( &__mask, ( &__v8di)  &__index,  &__addr,  &__scale,  &__hint); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_prefetch_i32gather_pd {
	    my($INDEX, $ADDR, $SCALE, $HINT) = @_;
    	    eval q( &__builtin_ia32_gatherpfdpd (( &__mmask8)0xff, ( &__v8si)( &__m256i) ($INDEX), ( &void  &const *) , , ($HINT)));
	}' unless defined(&_mm512_prefetch_i32gather_pd);
	eval 'sub _mm512_prefetch_i32gather_ps {
	    my($INDEX, $ADDR, $SCALE, $HINT) = @_;
    	    eval q( &__builtin_ia32_gatherpfdps (( &__mmask16)0xffff, ( &__v16si)( &__m512i) ($INDEX), ( &void  &const *) , , ($HINT)));
	}' unless defined(&_mm512_prefetch_i32gather_ps);
	eval 'sub _mm512_mask_prefetch_i32gather_pd {
	    my($INDEX, $MASK, $ADDR, $SCALE, $HINT) = @_;
    	    eval q( &__builtin_ia32_gatherpfdpd (( &__mmask8) ($MASK), ( &__v8si)( &__m256i) ($INDEX), ( &void  &const *) , , ($HINT)));
	}' unless defined(&_mm512_mask_prefetch_i32gather_pd);
	eval 'sub _mm512_mask_prefetch_i32gather_ps {
	    my($INDEX, $MASK, $ADDR, $SCALE, $HINT) = @_;
    	    eval q( &__builtin_ia32_gatherpfdps (( &__mmask16) ($MASK), ( &__v16si)( &__m512i) ($INDEX), ( &void  &const *) , , ($HINT)));
	}' unless defined(&_mm512_mask_prefetch_i32gather_ps);
	eval 'sub _mm512_prefetch_i64gather_pd {
	    my($INDEX, $ADDR, $SCALE, $HINT) = @_;
    	    eval q( &__builtin_ia32_gatherpfqpd (( &__mmask8)0xff, ( &__v8di)( &__m512i) ($INDEX), ( &void *) , , ($HINT)));
	}' unless defined(&_mm512_prefetch_i64gather_pd);
	eval 'sub _mm512_prefetch_i64gather_ps {
	    my($INDEX, $ADDR, $SCALE, $HINT) = @_;
    	    eval q( &__builtin_ia32_gatherpfqps (( &__mmask8)0xff, ( &__v8di)( &__m512i) ($INDEX), ( &void *) , , ($HINT)));
	}' unless defined(&_mm512_prefetch_i64gather_ps);
	eval 'sub _mm512_mask_prefetch_i64gather_pd {
	    my($INDEX, $MASK, $ADDR, $SCALE, $HINT) = @_;
    	    eval q( &__builtin_ia32_gatherpfqpd (( &__mmask8) ($MASK), ( &__v8di)( &__m512i) ($INDEX), ( &void *) , , ($HINT)));
	}' unless defined(&_mm512_mask_prefetch_i64gather_pd);
	eval 'sub _mm512_mask_prefetch_i64gather_ps {
	    my($INDEX, $MASK, $ADDR, $SCALE, $HINT) = @_;
    	    eval q( &__builtin_ia32_gatherpfqps (( &__mmask8) ($MASK), ( &__v8di)( &__m512i) ($INDEX), ( &void *) , , ($HINT)));
	}' unless defined(&_mm512_mask_prefetch_i64gather_ps);
	eval 'sub _mm512_prefetch_i32scatter_pd {
	    my($ADDR, $INDEX, $SCALE, $HINT) = @_;
    	    eval q( &__builtin_ia32_scatterpfdpd (( &__mmask8)0xff, ( &__v8si)( &__m256i) ($INDEX), ( &void *) , , ($HINT)));
	}' unless defined(&_mm512_prefetch_i32scatter_pd);
	eval 'sub _mm512_prefetch_i32scatter_ps {
	    my($ADDR, $INDEX, $SCALE, $HINT) = @_;
    	    eval q( &__builtin_ia32_scatterpfdps (( &__mmask16)0xffff, ( &__v16si)( &__m512i) ($INDEX), ( &void *) , , ($HINT)));
	}' unless defined(&_mm512_prefetch_i32scatter_ps);
	eval 'sub _mm512_mask_prefetch_i32scatter_pd {
	    my($ADDR, $MASK, $INDEX, $SCALE, $HINT) = @_;
    	    eval q( &__builtin_ia32_scatterpfdpd (( &__mmask8) ($MASK), ( &__v8si)( &__m256i) ($INDEX), ( &void *) , , ($HINT)));
	}' unless defined(&_mm512_mask_prefetch_i32scatter_pd);
	eval 'sub _mm512_mask_prefetch_i32scatter_ps {
	    my($ADDR, $MASK, $INDEX, $SCALE, $HINT) = @_;
    	    eval q( &__builtin_ia32_scatterpfdps (( &__mmask16) ($MASK), ( &__v16si)( &__m512i) ($INDEX), ( &void *) , , ($HINT)));
	}' unless defined(&_mm512_mask_prefetch_i32scatter_ps);
	eval 'sub _mm512_prefetch_i64scatter_pd {
	    my($ADDR, $INDEX, $SCALE, $HINT) = @_;
    	    eval q( &__builtin_ia32_scatterpfqpd (( &__mmask8)0xff, ( &__v8di)( &__m512i) ($INDEX), ( &void *) , , ($HINT)));
	}' unless defined(&_mm512_prefetch_i64scatter_pd);
	eval 'sub _mm512_prefetch_i64scatter_ps {
	    my($ADDR, $INDEX, $SCALE, $HINT) = @_;
    	    eval q( &__builtin_ia32_scatterpfqps (( &__mmask8)0xff, ( &__v8di)( &__m512i) ($INDEX), ( &void *) , , ($HINT)));
	}' unless defined(&_mm512_prefetch_i64scatter_ps);
	eval 'sub _mm512_mask_prefetch_i64scatter_pd {
	    my($ADDR, $MASK, $INDEX, $SCALE, $HINT) = @_;
    	    eval q( &__builtin_ia32_scatterpfqpd (( &__mmask8) ($MASK), ( &__v8di)( &__m512i) ($INDEX), ( &void *) , , ($HINT)));
	}' unless defined(&_mm512_mask_prefetch_i64scatter_pd);
	eval 'sub _mm512_mask_prefetch_i64scatter_ps {
	    my($ADDR, $MASK, $INDEX, $SCALE, $HINT) = @_;
    	    eval q( &__builtin_ia32_scatterpfqps (( &__mmask8) ($MASK), ( &__v8di)( &__m512i) ($INDEX), ( &void *) , , ($HINT)));
	}' unless defined(&_mm512_mask_prefetch_i64scatter_ps);
    }
    if(defined(&__DISABLE_AVX512PF__)) {
	undef(&__DISABLE_AVX512PF__) if defined(&__DISABLE_AVX512PF__);
    }
}
1;
