require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <avx512vbmiintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_AVX512VBMIINTRIN_H_INCLUDED)) {
    eval 'sub _AVX512VBMIINTRIN_H_INCLUDED () {1;}' unless defined(&_AVX512VBMIINTRIN_H_INCLUDED);
    unless(defined(&__AVX512VBMI__)) {
	eval 'sub __DISABLE_AVX512VBMI__ () {1;}' unless defined(&__DISABLE_AVX512VBMI__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_multishift_epi64_epi8 ( &__m512i  &__W,  &__mmask64  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_vpmultishiftqb512_mask (( &__v64qi)  &__X, ( &__v64qi)  &__Y, ( &__v64qi)  &__W, ( &__mmask64)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_multishift_epi64_epi8 ( &__mmask64  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_vpmultishiftqb512_mask (( &__v64qi)  &__X, ( &__v64qi)  &__Y, ( &__v64qi)  &_mm512_setzero_si512 (), ( &__mmask64)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_multishift_epi64_epi8 ( &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_vpmultishiftqb512_mask (( &__v64qi)  &__X, ( &__v64qi)  &__Y, ( &__v64qi)  &_mm512_undefined_epi32 (), ( &__mmask64) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_permutexvar_epi8 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_permvarqi512_mask (( &__v64qi)  &__B, ( &__v64qi)  &__A, ( &__v64qi)  &_mm512_undefined_epi32 (), ( &__mmask64) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_permutexvar_epi8 ( &__mmask64  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_permvarqi512_mask (( &__v64qi)  &__B, ( &__v64qi)  &__A, ( &__v64qi)  &_mm512_setzero_si512(), ( &__mmask64)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_permutexvar_epi8 ( &__m512i  &__W,  &__mmask64  &__M,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_permvarqi512_mask (( &__v64qi)  &__B, ( &__v64qi)  &__A, ( &__v64qi)  &__W, ( &__mmask64)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_permutex2var_epi8 ( &__m512i  &__A,  &__m512i  &__I,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_vpermt2varqi512_mask (( &__v64qi)  &__I , ( &__v64qi)  &__A, ( &__v64qi)  &__B, ( &__mmask64) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_permutex2var_epi8 ( &__m512i  &__A,  &__mmask64  &__U,  &__m512i  &__I,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_vpermt2varqi512_mask (( &__v64qi)  &__I , ( &__v64qi)  &__A, ( &__v64qi)  &__B, ( &__mmask64)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask2_permutex2var_epi8 ( &__m512i  &__A,  &__m512i  &__I,  &__mmask64  &__U,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_vpermi2varqi512_mask (( &__v64qi)  &__A, ( &__v64qi)  &__I , ( &__v64qi)  &__B, ( &__mmask64)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_permutex2var_epi8 ( &__mmask64  &__U,  &__m512i  &__A,  &__m512i  &__I,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_vpermt2varqi512_maskz (( &__v64qi)  &__I , ( &__v64qi)  &__A, ( &__v64qi)  &__B, ( &__mmask64)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_AVX512VBMI__)) {
	undef(&__DISABLE_AVX512VBMI__) if defined(&__DISABLE_AVX512VBMI__);
    }
}
1;
