require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <avx512vnnivlintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_AVX512VNNIVLINTRIN_H_INCLUDED)) {
    eval 'sub _AVX512VNNIVLINTRIN_H_INCLUDED () {1;}' unless defined(&_AVX512VNNIVLINTRIN_H_INCLUDED);
    if(!defined(&__AVX512VL__) || !defined(&__AVX512VNNI__)) {
	eval 'sub __DISABLE_AVX512VNNIVL__ () {1;}' unless defined(&__DISABLE_AVX512VNNIVL__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_dpbusd_epi32 ( &__m256i  &__A,  &__m256i  &__B,  &__m256i  &__C) { ( &__m256i)  &__builtin_ia32_vpdpbusd_v8si (( &__v8si) &__A, ( &__v8si)  &__B, ( &__v8si)  &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_dpbusd_epi32 ( &__m256i  &__A,  &__mmask8  &__B,  &__m256i  &__C,  &__m256i  &__D) { ( &__m256i) &__builtin_ia32_vpdpbusd_v8si_mask (( &__v8si) &__A, ( &__v8si)  &__C, ( &__v8si)  &__D, ( &__mmask8) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_dpbusd_epi32 ( &__mmask8  &__A,  &__m256i  &__B,  &__m256i  &__C,  &__m256i  &__D) { ( &__m256i) &__builtin_ia32_vpdpbusd_v8si_maskz (( &__v8si) &__B, ( &__v8si)  &__C, ( &__v8si)  &__D, ( &__mmask8) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_dpbusd_epi32 ( &__m128i  &__A,  &__m128i  &__B,  &__m128i  &__C) { ( &__m128i)  &__builtin_ia32_vpdpbusd_v4si (( &__v4si) &__A, ( &__v4si)  &__B, ( &__v4si)  &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_dpbusd_epi32 ( &__m128i  &__A,  &__mmask8  &__B,  &__m128i  &__C,  &__m128i  &__D) { ( &__m128i) &__builtin_ia32_vpdpbusd_v4si_mask (( &__v4si) &__A, ( &__v4si)  &__C, ( &__v4si)  &__D, ( &__mmask8) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_dpbusd_epi32 ( &__mmask8  &__A,  &__m128i  &__B,  &__m128i  &__C,  &__m128i  &__D) { ( &__m128i) &__builtin_ia32_vpdpbusd_v4si_maskz (( &__v4si) &__B, ( &__v4si)  &__C, ( &__v4si)  &__D, ( &__mmask8) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_dpbusds_epi32 ( &__m256i  &__A,  &__m256i  &__B,  &__m256i  &__C) { ( &__m256i)  &__builtin_ia32_vpdpbusds_v8si (( &__v8si) &__A, ( &__v8si)  &__B, ( &__v8si)  &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_dpbusds_epi32 ( &__m256i  &__A,  &__mmask8  &__B,  &__m256i  &__C,  &__m256i  &__D) { ( &__m256i) &__builtin_ia32_vpdpbusds_v8si_mask (( &__v8si) &__A, ( &__v8si)  &__C, ( &__v8si)  &__D, ( &__mmask8) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_dpbusds_epi32 ( &__mmask8  &__A,  &__m256i  &__B,  &__m256i  &__C,  &__m256i  &__D) { ( &__m256i) &__builtin_ia32_vpdpbusds_v8si_maskz (( &__v8si) &__B, ( &__v8si)  &__C, ( &__v8si)  &__D, ( &__mmask8) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_dpbusds_epi32 ( &__m128i  &__A,  &__m128i  &__B,  &__m128i  &__C) { ( &__m128i)  &__builtin_ia32_vpdpbusds_v4si (( &__v4si) &__A, ( &__v4si)  &__B, ( &__v4si)  &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_dpbusds_epi32 ( &__m128i  &__A,  &__mmask8  &__B,  &__m128i  &__C,  &__m128i  &__D) { ( &__m128i) &__builtin_ia32_vpdpbusds_v4si_mask (( &__v4si) &__A, ( &__v4si)  &__C, ( &__v4si)  &__D, ( &__mmask8) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_dpbusds_epi32 ( &__mmask8  &__A,  &__m128i  &__B,  &__m128i  &__C,  &__m128i  &__D) { ( &__m128i) &__builtin_ia32_vpdpbusds_v4si_maskz (( &__v4si) &__B, ( &__v4si)  &__C, ( &__v4si)  &__D, ( &__mmask8) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_dpwssd_epi32 ( &__m256i  &__A,  &__m256i  &__B,  &__m256i  &__C) { ( &__m256i)  &__builtin_ia32_vpdpwssd_v8si (( &__v8si) &__A, ( &__v8si)  &__B, ( &__v8si)  &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_dpwssd_epi32 ( &__m256i  &__A,  &__mmask8  &__B,  &__m256i  &__C,  &__m256i  &__D) { ( &__m256i) &__builtin_ia32_vpdpwssd_v8si_mask (( &__v8si) &__A, ( &__v8si)  &__C, ( &__v8si)  &__D, ( &__mmask8) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_dpwssd_epi32 ( &__mmask8  &__A,  &__m256i  &__B,  &__m256i  &__C,  &__m256i  &__D) { ( &__m256i) &__builtin_ia32_vpdpwssd_v8si_maskz (( &__v8si) &__B, ( &__v8si)  &__C, ( &__v8si)  &__D, ( &__mmask8) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_dpwssd_epi32 ( &__m128i  &__A,  &__m128i  &__B,  &__m128i  &__C) { ( &__m128i)  &__builtin_ia32_vpdpwssd_v4si (( &__v4si) &__A, ( &__v4si)  &__B, ( &__v4si)  &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_dpwssd_epi32 ( &__m128i  &__A,  &__mmask8  &__B,  &__m128i  &__C,  &__m128i  &__D) { ( &__m128i) &__builtin_ia32_vpdpwssd_v4si_mask (( &__v4si) &__A, ( &__v4si)  &__C, ( &__v4si)  &__D, ( &__mmask8) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_dpwssd_epi32 ( &__mmask8  &__A,  &__m128i  &__B,  &__m128i  &__C,  &__m128i  &__D) { ( &__m128i) &__builtin_ia32_vpdpwssd_v4si_maskz (( &__v4si) &__B, ( &__v4si)  &__C, ( &__v4si)  &__D, ( &__mmask8) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_dpwssds_epi32 ( &__m256i  &__A,  &__m256i  &__B,  &__m256i  &__C) { ( &__m256i)  &__builtin_ia32_vpdpwssds_v8si (( &__v8si) &__A, ( &__v8si)  &__B, ( &__v8si)  &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_dpwssds_epi32 ( &__m256i  &__A,  &__mmask8  &__B,  &__m256i  &__C,  &__m256i  &__D) { ( &__m256i) &__builtin_ia32_vpdpwssds_v8si_mask (( &__v8si) &__A, ( &__v8si)  &__C, ( &__v8si)  &__D, ( &__mmask8) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_dpwssds_epi32 ( &__mmask8  &__A,  &__m256i  &__B,  &__m256i  &__C,  &__m256i  &__D) { ( &__m256i) &__builtin_ia32_vpdpwssds_v8si_maskz (( &__v8si) &__B, ( &__v8si)  &__C, ( &__v8si)  &__D, ( &__mmask8) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_dpwssds_epi32 ( &__m128i  &__A,  &__m128i  &__B,  &__m128i  &__C) { ( &__m128i)  &__builtin_ia32_vpdpwssds_v4si (( &__v4si) &__A, ( &__v4si)  &__B, ( &__v4si)  &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_dpwssds_epi32 ( &__m128i  &__A,  &__mmask8  &__B,  &__m128i  &__C,  &__m128i  &__D) { ( &__m128i) &__builtin_ia32_vpdpwssds_v4si_mask (( &__v4si) &__A, ( &__v4si)  &__C, ( &__v4si)  &__D, ( &__mmask8) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_dpwssds_epi32 ( &__mmask8  &__A,  &__m128i  &__B,  &__m128i  &__C,  &__m128i  &__D) { ( &__m128i) &__builtin_ia32_vpdpwssds_v4si_maskz (( &__v4si) &__B, ( &__v4si)  &__C, ( &__v4si)  &__D, ( &__mmask8) &__A); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_AVX512VNNIVL__)) {
	undef(&__DISABLE_AVX512VNNIVL__) if defined(&__DISABLE_AVX512VNNIVL__);
    }
}
1;
