require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <gfniintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_GFNIINTRIN_H_INCLUDED)) {
    eval 'sub _GFNIINTRIN_H_INCLUDED () {1;}' unless defined(&_GFNIINTRIN_H_INCLUDED);
    if(!defined(&__GFNI__) || !defined(&__SSE2__)) {
	eval 'sub __DISABLE_GFNI__ () {1;}' unless defined(&__DISABLE_GFNI__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_gf2p8mul_epi8 ( &__m128i  &__A,  &__m128i  &__B) { ( &__m128i)  &__builtin_ia32_vgf2p8mulb_v16qi(( &__v16qi)  &__A, ( &__v16qi)  &__B); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_gf2p8affineinv_epi64_epi8 ( &__m128i  &__A,  &__m128i  &__B,  &const \'int\'  &__C) { ( &__m128i)  &__builtin_ia32_vgf2p8affineinvqb_v16qi (( &__v16qi)  &__A, ( &__v16qi)  &__B,  &__C); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_gf2p8affine_epi64_epi8 ( &__m128i  &__A,  &__m128i  &__B,  &const \'int\'  &__C) { ( &__m128i)  &__builtin_ia32_vgf2p8affineqb_v16qi (( &__v16qi)  &__A, ( &__v16qi)  &__B,  &__C); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_gf2p8affineinv_epi64_epi8 {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_vgf2p8affineinvqb_v16qi(( &__v16qi)( &__m128i)($A), ( &__v16qi)( &__m128i), ($C))));
	}' unless defined(&_mm_gf2p8affineinv_epi64_epi8);
	eval 'sub _mm_gf2p8affine_epi64_epi8 {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_vgf2p8affineqb_v16qi (( &__v16qi)( &__m128i)($A), ( &__v16qi)( &__m128i), ($C))));
	}' unless defined(&_mm_gf2p8affine_epi64_epi8);
    }
    if(defined(&__DISABLE_GFNI__)) {
	undef(&__DISABLE_GFNI__) if defined(&__DISABLE_GFNI__);
    }
    if(!defined(&__GFNI__) || !defined(&__AVX__)) {
	eval 'sub __DISABLE_GFNIAVX__ () {1;}' unless defined(&__DISABLE_GFNIAVX__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_gf2p8mul_epi8 ( &__m256i  &__A,  &__m256i  &__B) { ( &__m256i)  &__builtin_ia32_vgf2p8mulb_v32qi (( &__v32qi)  &__A, ( &__v32qi)  &__B); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_gf2p8affineinv_epi64_epi8 ( &__m256i  &__A,  &__m256i  &__B,  &const \'int\'  &__C) { ( &__m256i)  &__builtin_ia32_vgf2p8affineinvqb_v32qi (( &__v32qi)  &__A, ( &__v32qi)  &__B,  &__C); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_gf2p8affine_epi64_epi8 ( &__m256i  &__A,  &__m256i  &__B,  &const \'int\'  &__C) { ( &__m256i)  &__builtin_ia32_vgf2p8affineqb_v32qi (( &__v32qi)  &__A, ( &__v32qi)  &__B,  &__C); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm256_gf2p8affineinv_epi64_epi8 {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_vgf2p8affineinvqb_v32qi(( &__v32qi)( &__m256i)($A), ( &__v32qi)( &__m256i), ($C))));
	}' unless defined(&_mm256_gf2p8affineinv_epi64_epi8);
	eval 'sub _mm256_gf2p8affine_epi64_epi8 {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_vgf2p8affineqb_v32qi (( &__v32qi)( &__m256i)($A), (  &__v32qi)( &__m256i), ($C))));
	}' unless defined(&_mm256_gf2p8affine_epi64_epi8);
    }
    if(defined(&__DISABLE_GFNIAVX__)) {
	undef(&__DISABLE_GFNIAVX__) if defined(&__DISABLE_GFNIAVX__);
    }
    if(!defined(&__GFNI__) || !defined(&__AVX512VL__)) {
	eval 'sub __DISABLE_GFNIAVX512VL__ () {1;}' unless defined(&__DISABLE_GFNIAVX512VL__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_gf2p8mul_epi8 ( &__m128i  &__A,  &__mmask16  &__B,  &__m128i  &__C,  &__m128i  &__D) { ( &__m128i)  &__builtin_ia32_vgf2p8mulb_v16qi_mask (( &__v16qi)  &__C, ( &__v16qi)  &__D, ( &__v16qi) &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_gf2p8mul_epi8 ( &__mmask16  &__A,  &__m128i  &__B,  &__m128i  &__C) { ( &__m128i)  &__builtin_ia32_vgf2p8mulb_v16qi_mask (( &__v16qi)  &__B, ( &__v16qi)  &__C, ( &__v16qi)  &_mm_setzero_si128 (),  &__A); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_gf2p8affineinv_epi64_epi8 ( &__m128i  &__A,  &__mmask16  &__B,  &__m128i  &__C,  &__m128i  &__D,  &const \'int\'  &__E) { ( &__m128i)  &__builtin_ia32_vgf2p8affineinvqb_v16qi_mask (( &__v16qi)  &__C, ( &__v16qi)  &__D,  &__E, ( &__v16qi) &__A,  &__B); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_gf2p8affineinv_epi64_epi8 ( &__mmask16  &__A,  &__m128i  &__B,  &__m128i  &__C,  &const \'int\'  &__D) { ( &__m128i)  &__builtin_ia32_vgf2p8affineinvqb_v16qi_mask (( &__v16qi)  &__B, ( &__v16qi)  &__C,  &__D, ( &__v16qi)  &_mm_setzero_si128 (),  &__A); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_gf2p8affine_epi64_epi8 ( &__m128i  &__A,  &__mmask16  &__B,  &__m128i  &__C,  &__m128i  &__D,  &const \'int\'  &__E) { ( &__m128i)  &__builtin_ia32_vgf2p8affineqb_v16qi_mask (( &__v16qi)  &__C, ( &__v16qi)  &__D,  &__E, ( &__v16qi) &__A,  &__B); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_gf2p8affine_epi64_epi8 ( &__mmask16  &__A,  &__m128i  &__B,  &__m128i  &__C,  &const \'int\'  &__D) { ( &__m128i)  &__builtin_ia32_vgf2p8affineqb_v16qi_mask (( &__v16qi)  &__B, ( &__v16qi)  &__C,  &__D, ( &__v16qi)  &_mm_setzero_si128 (),  &__A); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_mask_gf2p8affineinv_epi64_epi8 {
	    my($A, $B, $C, $D, $E) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_vgf2p8affineinvqb_v16qi_mask( ( &__v16qi)( &__m128i)($C), ( &__v16qi)( &__m128i), ($E), ( &__v16qi)( &__m128i)($A), ( &__mmask16)($B))));
	}' unless defined(&_mm_mask_gf2p8affineinv_epi64_epi8);
	eval 'sub _mm_maskz_gf2p8affineinv_epi64_epi8 {
	    my($A, $B, $C, $D) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_vgf2p8affineinvqb_v16qi_mask( ( &__v16qi)( &__m128i)($B), ( &__v16qi)( &__m128i), ($D), ( &__v16qi)( &__m128i)  &_mm_setzero_si128 (), ( &__mmask16)($A))));
	}' unless defined(&_mm_maskz_gf2p8affineinv_epi64_epi8);
	eval 'sub _mm_mask_gf2p8affine_epi64_epi8 {
	    my($A, $B, $C, $D, $E) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_vgf2p8affineqb_v16qi_mask(( &__v16qi)( &__m128i)($C), ( &__v16qi)( &__m128i), ($E), ( &__v16qi)( &__m128i)($A), ( &__mmask16)($B))));
	}' unless defined(&_mm_mask_gf2p8affine_epi64_epi8);
	eval 'sub _mm_maskz_gf2p8affine_epi64_epi8 {
	    my($A, $B, $C, $D) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_vgf2p8affineqb_v16qi_mask(( &__v16qi)( &__m128i)($B), ( &__v16qi)( &__m128i), ($D), ( &__v16qi)( &__m128i)  &_mm_setzero_si128 (), ( &__mmask16)($A))));
	}' unless defined(&_mm_maskz_gf2p8affine_epi64_epi8);
    }
    if(defined(&__DISABLE_GFNIAVX512VL__)) {
	undef(&__DISABLE_GFNIAVX512VL__) if defined(&__DISABLE_GFNIAVX512VL__);
    }
    if(!defined(&__GFNI__) || !defined(&__AVX512VL__) || !defined(&__AVX512BW__)) {
	eval 'sub __DISABLE_GFNIAVX512VLBW__ () {1;}' unless defined(&__DISABLE_GFNIAVX512VLBW__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_gf2p8mul_epi8 ( &__m256i  &__A,  &__mmask32  &__B,  &__m256i  &__C,  &__m256i  &__D) { ( &__m256i)  &__builtin_ia32_vgf2p8mulb_v32qi_mask (( &__v32qi)  &__C, ( &__v32qi)  &__D, ( &__v32qi) &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_gf2p8mul_epi8 ( &__mmask32  &__A,  &__m256i  &__B,  &__m256i  &__C) { ( &__m256i)  &__builtin_ia32_vgf2p8mulb_v32qi_mask (( &__v32qi)  &__B, ( &__v32qi)  &__C, ( &__v32qi)  &_mm256_setzero_si256 (),  &__A); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_gf2p8affineinv_epi64_epi8 ( &__m256i  &__A,  &__mmask32  &__B,  &__m256i  &__C,  &__m256i  &__D,  &const \'int\'  &__E) { ( &__m256i)  &__builtin_ia32_vgf2p8affineinvqb_v32qi_mask (( &__v32qi)  &__C, ( &__v32qi)  &__D,  &__E, ( &__v32qi) &__A,  &__B); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_gf2p8affineinv_epi64_epi8 ( &__mmask32  &__A,  &__m256i  &__B,  &__m256i  &__C,  &const \'int\'  &__D) { ( &__m256i)  &__builtin_ia32_vgf2p8affineinvqb_v32qi_mask (( &__v32qi)  &__B, ( &__v32qi)  &__C,  &__D, ( &__v32qi)  &_mm256_setzero_si256 (),  &__A); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_gf2p8affine_epi64_epi8 ( &__m256i  &__A,  &__mmask32  &__B,  &__m256i  &__C,  &__m256i  &__D,  &const \'int\'  &__E) { ( &__m256i)  &__builtin_ia32_vgf2p8affineqb_v32qi_mask (( &__v32qi)  &__C, ( &__v32qi)  &__D,  &__E, ( &__v32qi) &__A,  &__B); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_gf2p8affine_epi64_epi8 ( &__mmask32  &__A,  &__m256i  &__B,  &__m256i  &__C,  &const \'int\'  &__D) { ( &__m256i)  &__builtin_ia32_vgf2p8affineqb_v32qi_mask (( &__v32qi)  &__B, ( &__v32qi)  &__C,  &__D, ( &__v32qi) &_mm256_setzero_si256 (),  &__A); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm256_mask_gf2p8affineinv_epi64_epi8 {
	    my($A, $B, $C, $D, $E) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_vgf2p8affineinvqb_v32qi_mask( ( &__v32qi)( &__m256i)($C), ( &__v32qi)( &__m256i), ($E), ( &__v32qi)( &__m256i)($A), ( &__mmask32)($B))));
	}' unless defined(&_mm256_mask_gf2p8affineinv_epi64_epi8);
	eval 'sub _mm256_maskz_gf2p8affineinv_epi64_epi8 {
	    my($A, $B, $C, $D) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_vgf2p8affineinvqb_v32qi_mask( ( &__v32qi)( &__m256i)($B), ( &__v32qi)( &__m256i), ($D), ( &__v32qi)( &__m256i)  &_mm256_setzero_si256 (), ( &__mmask32)($A))));
	}' unless defined(&_mm256_maskz_gf2p8affineinv_epi64_epi8);
	eval 'sub _mm256_mask_gf2p8affine_epi64_epi8 {
	    my($A, $B, $C, $D, $E) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_vgf2p8affineqb_v32qi_mask(( &__v32qi)( &__m256i)($C), ( &__v32qi)( &__m256i), ($E), ( &__v32qi)( &__m256i)($A), ( &__mmask32)($B))));
	}' unless defined(&_mm256_mask_gf2p8affine_epi64_epi8);
	eval 'sub _mm256_maskz_gf2p8affine_epi64_epi8 {
	    my($A, $B, $C, $D) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_vgf2p8affineqb_v32qi_mask(( &__v32qi)( &__m256i)($B), ( &__v32qi)( &__m256i), ($D), ( &__v32qi)( &__m256i)  &_mm256_setzero_si256 (), ( &__mmask32)($A))));
	}' unless defined(&_mm256_maskz_gf2p8affine_epi64_epi8);
    }
    if(defined(&__DISABLE_GFNIAVX512VLBW__)) {
	undef(&__DISABLE_GFNIAVX512VLBW__) if defined(&__DISABLE_GFNIAVX512VLBW__);
    }
    if(!defined(&__GFNI__) || !defined(&__AVX512F__) || !defined(&__AVX512BW__)) {
	eval 'sub __DISABLE_GFNIAVX512FBW__ () {1;}' unless defined(&__DISABLE_GFNIAVX512FBW__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_gf2p8mul_epi8 ( &__m512i  &__A,  &__mmask64  &__B,  &__m512i  &__C,  &__m512i  &__D) { ( &__m512i)  &__builtin_ia32_vgf2p8mulb_v64qi_mask (( &__v64qi)  &__C, ( &__v64qi)  &__D, ( &__v64qi) &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_gf2p8mul_epi8 ( &__mmask64  &__A,  &__m512i  &__B,  &__m512i  &__C) { ( &__m512i)  &__builtin_ia32_vgf2p8mulb_v64qi_mask (( &__v64qi)  &__B, ( &__v64qi)  &__C, ( &__v64qi)  &_mm512_setzero_si512 (),  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_gf2p8mul_epi8 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_vgf2p8mulb_v64qi (( &__v64qi)  &__A, ( &__v64qi)  &__B); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_gf2p8affineinv_epi64_epi8 ( &__m512i  &__A,  &__mmask64  &__B,  &__m512i  &__C,  &__m512i  &__D,  &const \'int\'  &__E) { ( &__m512i)  &__builtin_ia32_vgf2p8affineinvqb_v64qi_mask (( &__v64qi)  &__C, ( &__v64qi)  &__D,  &__E, ( &__v64qi) &__A,  &__B); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_gf2p8affineinv_epi64_epi8 ( &__mmask64  &__A,  &__m512i  &__B,  &__m512i  &__C,  &const \'int\'  &__D) { ( &__m512i)  &__builtin_ia32_vgf2p8affineinvqb_v64qi_mask (( &__v64qi)  &__B, ( &__v64qi)  &__C,  &__D, ( &__v64qi)  &_mm512_setzero_si512 (),  &__A); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_gf2p8affineinv_epi64_epi8 ( &__m512i  &__A,  &__m512i  &__B,  &const \'int\'  &__C) { ( &__m512i)  &__builtin_ia32_vgf2p8affineinvqb_v64qi (( &__v64qi)  &__A, ( &__v64qi)  &__B,  &__C); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_gf2p8affine_epi64_epi8 ( &__m512i  &__A,  &__mmask64  &__B,  &__m512i  &__C,  &__m512i  &__D,  &const \'int\'  &__E) { ( &__m512i)  &__builtin_ia32_vgf2p8affineqb_v64qi_mask (( &__v64qi)  &__C, ( &__v64qi)  &__D,  &__E, ( &__v64qi) &__A,  &__B); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_gf2p8affine_epi64_epi8 ( &__mmask64  &__A,  &__m512i  &__B,  &__m512i  &__C,  &const \'int\'  &__D) { ( &__m512i)  &__builtin_ia32_vgf2p8affineqb_v64qi_mask (( &__v64qi)  &__B, ( &__v64qi)  &__C,  &__D, ( &__v64qi)  &_mm512_setzero_si512 (),  &__A); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_gf2p8affine_epi64_epi8 ( &__m512i  &__A,  &__m512i  &__B,  &const \'int\'  &__C) { ( &__m512i)  &__builtin_ia32_vgf2p8affineqb_v64qi (( &__v64qi)  &__A, ( &__v64qi)  &__B,  &__C); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_mask_gf2p8affineinv_epi64_epi8 {
	    my($A, $B, $C, $D, $E) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_vgf2p8affineinvqb_v64qi_mask( ( &__v64qi)( &__m512i)($C), ( &__v64qi)( &__m512i), ($E), ( &__v64qi)( &__m512i)($A), ( &__mmask64)($B))));
	}' unless defined(&_mm512_mask_gf2p8affineinv_epi64_epi8);
	eval 'sub _mm512_maskz_gf2p8affineinv_epi64_epi8 {
	    my($A, $B, $C, $D) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_vgf2p8affineinvqb_v64qi_mask( ( &__v64qi)( &__m512i)($B), ( &__v64qi)( &__m512i), ($D), ( &__v64qi)( &__m512i)  &_mm512_setzero_si512 (), ( &__mmask64)($A))));
	}' unless defined(&_mm512_maskz_gf2p8affineinv_epi64_epi8);
	eval 'sub _mm512_gf2p8affineinv_epi64_epi8 {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_vgf2p8affineinvqb_v64qi ( ( &__v64qi)( &__m512i)($A), ( &__v64qi)( &__m512i), ($C))));
	}' unless defined(&_mm512_gf2p8affineinv_epi64_epi8);
	eval 'sub _mm512_mask_gf2p8affine_epi64_epi8 {
	    my($A, $B, $C, $D, $E) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_vgf2p8affineqb_v64qi_mask(( &__v64qi)( &__m512i)($C), ( &__v64qi)( &__m512i), ($E), ( &__v64qi)( &__m512i)($A), ( &__mmask64)($B))));
	}' unless defined(&_mm512_mask_gf2p8affine_epi64_epi8);
	eval 'sub _mm512_maskz_gf2p8affine_epi64_epi8 {
	    my($A, $B, $C, $D) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_vgf2p8affineqb_v64qi_mask(( &__v64qi)( &__m512i)($B), ( &__v64qi)( &__m512i), ($D), ( &__v64qi)( &__m512i)  &_mm512_setzero_si512 (), ( &__mmask64)($A))));
	}' unless defined(&_mm512_maskz_gf2p8affine_epi64_epi8);
	eval 'sub _mm512_gf2p8affine_epi64_epi8 {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_vgf2p8affineqb_v64qi (( &__v64qi)( &__m512i)($A), ( &__v64qi)( &__m512i), ($C))));
	}' unless defined(&_mm512_gf2p8affine_epi64_epi8);
    }
    if(defined(&__DISABLE_GFNIAVX512FBW__)) {
	undef(&__DISABLE_GFNIAVX512FBW__) if defined(&__DISABLE_GFNIAVX512FBW__);
    }
}
1;
