require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <vpclmulqdqintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_VPCLMULQDQINTRIN_H_INCLUDED)) {
    eval 'sub _VPCLMULQDQINTRIN_H_INCLUDED () {1;}' unless defined(&_VPCLMULQDQINTRIN_H_INCLUDED);
    if(!defined(&__VPCLMULQDQ__) || !defined(&__AVX512F__)) {
	eval 'sub __DISABLE_VPCLMULQDQF__ () {1;}' unless defined(&__DISABLE_VPCLMULQDQF__);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_clmulepi64_epi128 ( &__m512i  &__A,  &__m512i  &__B,  &const \'int\'  &__C) { ( &__m512i)  &__builtin_ia32_vpclmulqdq_v8di (( &__v8di) &__A, ( &__v8di)  &__B,  &__C); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_clmulepi64_epi128 {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_vpclmulqdq_v8di (( &__v8di)( &__m512i)($A), ( &__v8di)( &__m512i), ($C))));
	}' unless defined(&_mm512_clmulepi64_epi128);
    }
    if(defined(&__DISABLE_VPCLMULQDQF__)) {
	undef(&__DISABLE_VPCLMULQDQF__) if defined(&__DISABLE_VPCLMULQDQF__);
    }
    if(!defined(&__VPCLMULQDQ__) || !defined(&__AVX__)) {
	eval 'sub __DISABLE_VPCLMULQDQ__ () {1;}' unless defined(&__DISABLE_VPCLMULQDQ__);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_clmulepi64_epi128 ( &__m256i  &__A,  &__m256i  &__B,  &const \'int\'  &__C) { ( &__m256i)  &__builtin_ia32_vpclmulqdq_v4di (( &__v4di) &__A, ( &__v4di)  &__B,  &__C); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm256_clmulepi64_epi128 {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_vpclmulqdq_v4di (( &__v4di)( &__m256i)($A), ( &__v4di)( &__m256i), ($C))));
	}' unless defined(&_mm256_clmulepi64_epi128);
    }
    if(defined(&__DISABLE_VPCLMULQDQ__)) {
	undef(&__DISABLE_VPCLMULQDQ__) if defined(&__DISABLE_VPCLMULQDQ__);
    }
}
1;
