require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_I386_ASM_H_)) {
    eval 'sub _I386_ASM_H_ () {1;}' unless defined(&_I386_ASM_H_);
    if(defined(&_KERNEL_OPT)) {
	require './i386/opt_multiprocessor.ph';
    }
    if(defined(&__PIC__)) {
	eval 'sub PIC_PROLOGUE () { &pushl % &ebx;  &call 1 &f; 1:  &popl % &ebx;  &addl $ &_GLOBAL_OFFSET_TABLE_+[.-1 &b], % &ebx;}' unless defined(&PIC_PROLOGUE);
	eval 'sub PIC_EPILOGUE () { &popl % &ebx;}' unless defined(&PIC_EPILOGUE);
	eval 'sub PIC_PLT {
	    my($x) = @_;
    	    eval q($x@ &PLT);
	}' unless defined(&PIC_PLT);
	eval 'sub PIC_GOT {
	    my($x) = @_;
    	    eval q($x@ &GOT(% &ebx));
	}' unless defined(&PIC_GOT);
	eval 'sub PIC_GOTOFF {
	    my($x) = @_;
    	    eval q($x@ &GOTOFF(% &ebx));
	}' unless defined(&PIC_GOTOFF);
    } else {
	eval 'sub PIC_PROLOGUE () {1;}' unless defined(&PIC_PROLOGUE);
	eval 'sub PIC_EPILOGUE () {1;}' unless defined(&PIC_EPILOGUE);
	eval 'sub PIC_PLT {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&PIC_PLT);
	eval 'sub PIC_GOT {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&PIC_GOT);
	eval 'sub PIC_GOTOFF {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&PIC_GOTOFF);
    }
    if(defined(&__ELF__)) {
	eval 'sub _C_LABEL {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&_C_LABEL);
    } else {
	if(defined(&__STDC__)) {
	    eval 'sub _C_LABEL {
	        my($x) = @_;
    		eval q( &_  $x);
	    }' unless defined(&_C_LABEL);
	} else {
	    eval 'sub _C_LABEL {
	        my($x) = @_;
    		eval q( &_ $x);
	    }' unless defined(&_C_LABEL);
	}
    }
    eval 'sub _ASM_LABEL {
        my($x) = @_;
	    eval q($x);
    }' unless defined(&_ASM_LABEL);
    eval 'sub CVAROFF {
        my($x, $y) = @_;
	    eval q( &_C_LABEL($x) + $y);
    }' unless defined(&CVAROFF);
    if(defined(&__STDC__)) {
	eval 'sub __CONCAT {
	    my($x,$y) = @_;
    	    eval q($x  $y);
	}' unless defined(&__CONCAT);
	eval 'sub __STRING {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&__STRING);
    } else {
	eval 'sub __CONCAT {
	    my($x,$y) = @_;
    	    eval q($x $y);
	}' unless defined(&__CONCAT);
	eval 'sub __STRING {
	    my($x) = @_;
    	    eval q(\\"x\\");
	}' unless defined(&__STRING);
    }
    if(!defined(&_ALIGN_TEXT)  && !defined(&_KERNEL)) {
	if(defined(&_STANDALONE)) {
	    eval 'sub _ALIGN_TEXT () {. &align 1;}' unless defined(&_ALIGN_TEXT);
	}
 elsif(defined (&__ELF__)) {
	    eval 'sub _ALIGN_TEXT () {. &align 16;}' unless defined(&_ALIGN_TEXT);
	} else {
	    eval 'sub _ALIGN_TEXT () {. &align 4;}' unless defined(&_ALIGN_TEXT);
	}
    }
    eval 'sub _ENTRY {
        my($x) = @_;
	    eval q(. &text;  &_ALIGN_TEXT; . &globl $x; . &type $x,@ &function; $x:);
    }' unless defined(&_ENTRY);
    eval 'sub _LABEL {
        my($x) = @_;
	    eval q(. &globl $x; $x:);
    }' unless defined(&_LABEL);
    if(defined(&_KERNEL)) {
	eval 'sub CPUVAR {
	    my($off) = @_;
    	    eval q(% &fs: &__CONCAT( &CPU_INFO_,$off));
	}' unless defined(&CPUVAR);
	if(defined(&__ELF__)) {
	    if(defined(&__STDC__)) {
		eval 'sub IDTVEC {
		    my($name) = @_;
    		    eval q( &ALIGN_TEXT; . &globl  &X  $name; . &type  &X  $name,@ &function;  &X  $name:);
		}' unless defined(&IDTVEC);
		eval 'sub IDTVEC_END {
		    my($name) = @_;
    		    eval q(. &size  &X  $name, . -  &X  $name);
		}' unless defined(&IDTVEC_END);
	    } else {
		eval 'sub IDTVEC {
		    my($name) = @_;
    		    eval q( &ALIGN_TEXT; . &globl  &X $name; . &type  &X $name,@ &function;  &X $name:);
		}' unless defined(&IDTVEC);
		eval 'sub IDTVEC_END {
		    my($name) = @_;
    		    eval q(. &size  &X $name, . -  &X $name);
		}' unless defined(&IDTVEC_END);
	    }
	} else {
	    if(defined(&__STDC__)) {
		eval 'sub IDTVEC {
		    my($name) = @_;
    		    eval q( &ALIGN_TEXT; . &globl  &_X  $name; . &type  &_X  $name,@ &function;  &_X  $name:);
		}' unless defined(&IDTVEC);
		eval 'sub IDTVEC_END {
		    my($name) = @_;
    		    eval q(. &size  &_X  $name, . -  &_X  $name);
		}' unless defined(&IDTVEC_END);
	    } else {
		eval 'sub IDTVEC {
		    my($name) = @_;
    		    eval q( &ALIGN_TEXT; . &globl  &_X $name; . &type  &_X $name,@ &function;  &_X $name:);
		}' unless defined(&IDTVEC);
		eval 'sub IDTVEC_END {
		    my($name) = @_;
    		    eval q(. &size  &_X $name, . -  &_X $name);
		}' unless defined(&IDTVEC_END);
	    }
	}
	if(defined(&_STANDALONE)) {
	    eval 'sub ALIGN_DATA () {. &align 4;}' unless defined(&ALIGN_DATA);
	    eval 'sub ALIGN_TEXT () {. &align 4;}' unless defined(&ALIGN_TEXT);
	    eval 'sub SUPERALIGN_TEXT () {. &align 16;}' unless defined(&SUPERALIGN_TEXT);
	}
 elsif(defined (&__ELF__)) {
	    eval 'sub ALIGN_DATA () {. &align 4;}' unless defined(&ALIGN_DATA);
	    eval 'sub ALIGN_TEXT () {. &align 16;}' unless defined(&ALIGN_TEXT);
	    eval 'sub SUPERALIGN_TEXT () {. &align 16;}' unless defined(&SUPERALIGN_TEXT);
	} else {
	    eval 'sub ALIGN_DATA () {. &align 2;}' unless defined(&ALIGN_DATA);
	    eval 'sub ALIGN_TEXT () {. &align 4;}' unless defined(&ALIGN_TEXT);
	    eval 'sub SUPERALIGN_TEXT () {. &align 4;}' unless defined(&SUPERALIGN_TEXT);
	}
	eval 'sub _ALIGN_TEXT () { &ALIGN_TEXT;}' unless defined(&_ALIGN_TEXT);
	if(defined(&GPROF)) {
	    if(defined(&__ELF__)) {
		eval 'sub MCOUNT_ASM () { &call  &_C_LABEL( &__mcount);}' unless defined(&MCOUNT_ASM);
	    } else {
		eval 'sub MCOUNT_ASM () { &call  &_C_LABEL( &mcount);}' unless defined(&MCOUNT_ASM);
	    }
	} else {
	    eval 'sub MCOUNT_ASM () {1;}' unless defined(&MCOUNT_ASM);
	}
    }
    if(defined(&GPROF)) {
	if(defined(&__ELF__)) {
	    eval 'sub _PROF_PROLOGUE () { &pushl % &ebp;  &movl % &esp,% &ebp;  &call  &PIC_PLT( &__mcount);  &popl % &ebp;}' unless defined(&_PROF_PROLOGUE);
	} else {
	    eval 'sub _PROF_PROLOGUE () { &pushl % &ebp;  &movl % &esp,% &ebp;  &call  &PIC_PLT( &mcount);  &popl % &ebp;}' unless defined(&_PROF_PROLOGUE);
	}
    } else {
	eval 'sub _PROF_PROLOGUE () {1;}' unless defined(&_PROF_PROLOGUE);
    }
    eval 'sub ENTRY {
        my($y) = @_;
	    eval q( &_ENTRY( &_C_LABEL($y));  &_PROF_PROLOGUE);
    }' unless defined(&ENTRY);
    eval 'sub NENTRY {
        my($y) = @_;
	    eval q( &_ENTRY( &_C_LABEL($y)));
    }' unless defined(&NENTRY);
    eval 'sub ALTENTRY {
        my($x) = @_;
	    eval q( &NENTRY($x));
    }' unless defined(&ALTENTRY);
    eval 'sub ASENTRY {
        my($y) = @_;
	    eval q( &_ENTRY( &_ASM_LABEL($y));  &_PROF_PROLOGUE);
    }' unless defined(&ASENTRY);
    eval 'sub LABEL {
        my($y) = @_;
	    eval q( &_LABEL( &_C_LABEL($y)));
    }' unless defined(&LABEL);
    eval 'sub END {
        my($y) = @_;
	    eval q(. &size $y, . - $y);
    }' unless defined(&END);
    eval 'sub ASMSTR () {. &asciz;}' unless defined(&ASMSTR);
    if(defined(&__ELF__)) {
	eval 'sub RCSID {
	    my($x) = @_;
    	    eval q(. &pushsection \\".ident\\",\\"MS\\",@ &progbits,1; . &asciz $x; . &popsection);
	}' unless defined(&RCSID);
    } else {
	eval 'sub RCSID {
	    my($x) = @_;
    	    eval q(. &text; . &asciz $x);
	}' unless defined(&RCSID);
    }
    if(defined(&NO_KERNEL_RCSIDS)) {
	eval 'sub __KERNEL_RCSID {
	    my($_n, $_s) = @_;
    	    eval q();
	}' unless defined(&__KERNEL_RCSID);
    } else {
	eval 'sub __KERNEL_RCSID {
	    my($_n, $_s) = @_;
    	    eval q( &RCSID($_s));
	}' unless defined(&__KERNEL_RCSID);
    }
    if(defined(&__ELF__)) {
	eval 'sub WEAK_ALIAS {
	    my($alias,$sym) = @_;
    	    eval q(. &weak $alias; $alias = $sym);
	}' unless defined(&WEAK_ALIAS);
    }
    eval 'sub STRONG_ALIAS {
        my($alias,$sym) = @_;
	    eval q(. &globl $alias; $alias = $sym);
    }' unless defined(&STRONG_ALIAS);
    if(defined(&__STDC__)) {
	eval 'sub WARN_REFERENCES {
	    my($sym,$msg) = @_;
    	    eval q(. &pushsection . ($gnu->{warning}).  $sym; . &ascii $msg; . &popsection);
	}' unless defined(&WARN_REFERENCES);
    } else {
	eval 'sub WARN_REFERENCES {
	    my($sym,$msg) = @_;
    	    eval q(. &pushsection . ($gnu->{warning}). $sym; . &ascii $msg; . &popsection);
	}' unless defined(&WARN_REFERENCES);
    }
}
1;
